/* OS- and machine-dependent stuff for IBM-PC running MS-DOS */

/* 2/19/88 B. Doster - added support for "urgent" data (needed for SL/FP) */
/* 2/23/88 B. Doster - added Timeout for Transmit Complete IRQ		  */
 
#if defined(__TURBOC__)
#pragma inline
#endif

#include <stdio.h>
#include "global.h"

#if defined(PLUS)
#include "plus.h"
#else
#include "pc.h"
#endif

#include "timer.h"
#include "asy.h"
#include "iface.h"

struct asy asy[ASY_MAX];
unsigned nasy;

#if defined(__TURBOC__)
extern unsigned char intstk[];
extern unsigned int sssave, spsave;

typedef unsigned char byte; 
byte model;			/* 0 = portable plus
				   1 = portable
				   2 = ibmpc type     */
/*
 =================================================================
 */
int	 _Cdecl inport	(int portid);
unsigned char	_Cdecl inportb(int portid);
void	 _Cdecl outport	(int portid, int value);
void	 _Cdecl outportb(int portid, unsigned char value);
unsigned char _Cdecl __inportb__(int portid);
void	_Cdecl	__outportb__	(int portid, unsigned char value);
#define inportb(portid) __inportb__(portid)	/* Byte IN instruction */
#define outportb(portid, v) __outportb__(portid,v)/* Byte OUT instruction */
#define inp(portid)	inportb(portid)
#define outp(portid,v)	outportb(portid,v)
#define geninterrupt(i)	__int__(i)
void	 _Cdecl setvect	(int interruptno, void interrupt (*isr) ());
void	interrupt 	(* _Cdecl getvect(int interruptno)) ();
int (*getirq())();

#if defined(PLUS)
int16 modemdev, serialdev;
struct plusasy plusasy[ASY_MAX];
/* ASY interrupt handlers */
byte modemconfig, serialconfig;
extern void interrupt plustxsvec();
extern void interrupt plusrxsvec();
extern void interrupt plustxmvec();
extern void interrupt plusrxmvec();
byte *com1_name="COM1";         /* file to open  for serial		    */
byte *com3_name="COM3";         /* file to open for modem		    */
int com1handle;			/* file handle saved here		    */
int com3handle;			/* file handle saved here		    */
byte *ioctlon1="M1;";           /* IOCTL to turn on  serial port            */
byte *ioctloff1="M3;";          /* IOCTL to turn off serial port            */
byte *ioctlon3="M4;";           /* IOCTL to turn on  modem port            */
byte *ioctloff3="M5;";          /* IOCTL to turn off modem port            */

#else				/* it's turbo but not defined(PLUS)    */

/* ASY interrupt handlers
 */

interrupt asy0vec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asyint(0);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	doret();
}

interrupt asy1vec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asyint(1);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	doret();
}

interrupt asy2vec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asyint(2);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	doret();
}

interrupt asy3vec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asyint(3);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	doret();
}

interrupt asy4vec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asyint(4);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	doret();
}

interrupt (*handle[])() = {asy0vec,asy1vec,asy2vec,asy3vec,asy4vec};
#endif		/* if defined(PLUS) */
/* 
 * moved here because of re-definition problem with dos.h in
 *  turbo c; in non turboc version this is in pcgen.asm
 *
 * disable - disable interrupts and return previous state: 0 = disabled,
 *           1 = enabled
 */
int disable()
{
	asm pushf		/* save state on stack		*/
	asm cli			/* interrupts off		*/
	asm pop ax		/* original flags -> ax		*/
	asm and ax,200h		/* 1<<9 is IF bit		*/
	asm jnz ion		/* nonzero -> interrupts were on*/
	return(_AX);
ion:
	return(1);
}
#else

/* ASY interrupt handlers */
extern int asy0vec(),asy1vec(),asy2vec(),asy3vec(),asy4vec();
int (*handle[])() = {asy0vec,asy1vec,asy2vec,asy3vec,asy4vec};

#endif          /* if defined(__TURBOC__) */
  
/* Initialize asynch port "dev" */
int
asy_init(dev,bufsize)
int16 dev;
unsigned bufsize;
{
    register unsigned base;
    register struct fifo *fp;
    register struct asy *ap;
    void asy_xmt_to();
  
    ap = &asy[dev];
    /* Set up receiver FIFO */
    fp = &ap->fifo;
    if((fp->buf = malloc(bufsize)) == NULLCHAR){
        printf("asy%d: No space for rx buffer\r\n");
        fflush(stdout);
        return;
    }
    fp->bufsize = bufsize;
    fp->wp = fp->rp = fp->buf;
    fp->cnt = 0;
  
    base = ap->addr;

    ap->urgent = NULLCHAR ;			/* for SL/FP Urgent Data */
    ap->dma.xmt_to.func = asy_xmt_to ;		/* for Xmt Cplt TO handling */
    ap->dma.xmt_to.arg = (char *)dev ;		/* for Xmt Cplt TO handling */
    ap->dma.cnt_xmt_to = 0 ;			/* for Xmt Cplt TO handling */

#if defined(PLUS)
    /* Purge the receive data buffer
     * Set line control register: 8 bits, no parity
     *
     * Turn on receive interrupt enable, leave transmit
     * interrupts turned off for now
     *
     * Set modem control register: assert DTR, RTS, turn on serial
     * port
     *
     * Enable rx interrupt
     */
    (void)init_com(dev,'N',1);
    /* Set interrupt vector to SIO handler
     *  DON'T bump them by 8 as we use the actual
     *  interrupt numbers, not the number -8 as int
     *  the pc asy entry.
     *
     *  If the computer is a portable only the serial interrupts are used
     *  If the computer is a P+ both serial and modem interrupts are used
     *
     *                     110    110p serial   110p modem
     *          rx vector  0x4f       0x4f	   0x4e
     *          tx vector  0x4a       0x4a	   0x40
     *          base addr  0xa4       0x44         0xa4   
     *
     */
    if(base==0x44 || model==1) {
	plusasy[dev].oldrx=getvect(0x4f);
	plusasy[dev].oldtx=getvect(0x4a);
	if(model==1) {
		asy[dev].addr=0xa4;
    		setvect(0x4a,plustxmvec);
    		setvect(0x4f,plusrxmvec);
		modemdev=dev;
	}
	else {
		setvect(0x4a,plustxsvec);
		setvect(0x4f,plusrxsvec);
		serialdev=dev;
	}
    }
    else { /* address not 0x44 and not a portable, must be plus modem */
	plusasy[dev].oldrx=getvect(0x4e);
	plusasy[dev].oldtx=getvect(0x40);
	setvect(0x40,plustxmvec);
	setvect(0x4e,plusrxmvec);
	modemdev=dev;
    }
 #else   /* it' a PC */
    /* Save original interrupt vector */
    ap->oldvec = getirq(ap->vec);

    /* Set interrupt vector to SIO handler */
    setirq(ap->vec,handle[dev]);

    /* Purge the receive data buffer */
    (void)inportb(base+RBR);

    /* Set line control register: 8 bits, no parity */
    outportb(base+LCR,(char)LCR_8BITS);

    /* Turn on receive interrupt enable in 8250, leave transmit
     * and modem status interrupts turned off for now
     */
    outportb(base+IER,(char)IER_DAV);

    /* Set modem control register: assert DTR, RTS, turn on 8250
     * master interrupt enable (connected to OUT2)
     */
    outportb(base+MCR,(char)(MCR_DTR|MCR_RTS|MCR_OUT2));

    /* Clear mask (enable interrupt) in 8259 interrupt controller */
    maskon(ap->vec);
#endif
} /* asy_init */
int
asy_stop(iface)
struct interface *iface;
{
    register unsigned base;
    register struct asy *ap;
  
    ap = &asy[iface->dev];
    base = ap->addr;
  
#if defined(PLUS)
/*
 * hardware ints off
 */
    outportb(base+INTRCONTROL,(unsigned char)0xf0);
/*
 * turn off power to the serial port and
 * Restore original interrupt vectors
 */
    if(base==0x44 || model==1) {
    	serial_power(0);
    	setvect(0x4f,plusasy[iface->dev].oldrx);
    	setvect(0x4a,plusasy[iface->dev].oldtx);
    }
    else {
/*
 * commented out so we can use the modem
    	modem_power(0);
 */
    	setvect(0x4e,plusasy[iface->dev].oldrx);
    	setvect(0x40,plusasy[iface->dev].oldtx);
    }
    return(0);
#else   /* it' a PC */
    /* Ensure that DLAB bit is off */
    outportb(base+LCR,(char)LCR_8BITS);
  
    /* Turn off all 8250 interrupt enable bits */
    outportb(base+IER,(char)0);
  
    /* Turn off DTR, RTS, master interrupt enable */
    outportb(base+MCR,(char)0);
  
    /* Set 8259 interrupt mask (turn off interrupts) */
    maskoff(ap->vec);
  
    /* Restore original interrupt vector */
    setirq(ap->vec,ap->oldvec);
#endif
}
/* Asynchronous line I/O control */
asy_ioctl(interface,argc,argv)
struct interface *interface;
int argc;
char *argv[];
{
    if(argc < 1){
        printf("%d\r\n",asy[interface->dev].speed);
        return 0;
    }
    return asy_speed(interface->dev,atoi(argv[0]));
}
/* Set asynch line speed */
int
asy_speed(dev,speed)
int16 dev;
int speed;
{
    register unsigned base;
    register int divisor;
    char i_state;
  
    if(speed == 0 || dev >= nasy)
        return;
  
    base = asy[dev].addr;
    asy[dev].speed = speed;
#if defined(PLUS)
/*
 *  Setup baud rate
 */
    divisor=1333500L/speed - 1;
    i_state = disable();
    outportb((unsigned)(base+BAUDLO), (unsigned char)(divisor));
    outportb((unsigned)(base+BAUDHI), (unsigned char)(divisor>>8));
#else   /* it' a PC, and turbo c, but not a HP-110 */
    divisor = BAUDCLK / (long)speed;
  
    i_state = disable();
  
    /* Purge the receive data buffer */
    (void)inportb(base+RBR);
  
    /* Turn on divisor latch access bit */
    setbit(base+LCR,LCR_DLAB);
  
    /* Load the two bytes of the register */
    outportb(base+DLL,(char)(divisor & 0xff));      /* Low byte */
    outportb(base+DLM,(char)((divisor >> 8) & 0xff));   /* Hi byte */
  
    /* Turn off divisor latch access bit */
    clrbit(base+LCR,LCR_DLAB);
 #endif 
    restore(i_state);
}
/* Send a buffer to serial transmitter */
asy_output(dev,buf,cnt)
unsigned dev;
char *buf;
unsigned short cnt;
{
    register struct dma *dp;
    unsigned base;
    char i_state;
  
    if(dev >= nasy)
        return;
    fflush(stdout);
    base = asy[dev].addr;
    dp = &asy[dev].dma;
    i_state = disable();
    if(dp->flags){
        restore(i_state);
        return; /* Already busy */
    }
    dp->data = buf;
    dp->cnt = cnt;
    dp->flags = 1;

    /* Start Timer for Completion of Byte Xmit (1/4 Sec for each Byte) */
    set_timer(&dp->xmt_to,250) ;
    start_timer(&dp->xmt_to) ;

    /* Enable transmitter buffer empty interrupt and simulate
     * an interrupt; this will get things rolling.
     */
#if defined(PLUS)
    clrbit(base+INTRCONTROL,0x80);
    setbit(base+INTRCONTROL,0x40);
#else   /* it' a PC */
    setbit(base+IER,IER_TxE);
#endif
    asytxint(dev);
    restore(i_state);
}
/* Receive characters from asynch line
 * Returns count of characters read
 */
int16
asy_recv(dev,buf,cnt)
int16 dev;
char *buf;
unsigned cnt;
{
    unsigned tot,n;
    int kbread();
    char i_state;
    struct fifo *fp;
  
    fp = &asy[dev].fifo;
    tot = 0;
    /* Read from serial I/O input buffer */
    i_state = disable();
    for(;;){
        n = min(cnt,fp->cnt);
        if(n == 0)
            break;
        n = min(n,&fp->buf[fp->bufsize] - fp->rp);
        memcpy(buf,fp->rp,n);
        fp->rp += n;
        if(fp->rp >= &fp->buf[fp->bufsize])
            fp->rp = fp->buf;
        fp->cnt -= n;
        buf += n;
        tot += n;
        cnt -= n;
    }
    restore(i_state);
    return tot;
  
}
#if !defined(PLUS)
/* Interrupt handler for 8250 asynch chip */
asyint(dev)
unsigned dev;
{
    register unsigned base;
    register char iir;
  
    base = asy[dev].addr;
    while(((iir = inportb(base+IIR)) & IIR_IP) == 0){
        switch(iir & IIR_ID){
            case IIR_RDA:   /* Receiver interrupt */
                asyrxint(dev);
                break;
            case IIR_THRE:  /* Transmit interrupt */
                asytxint(dev);
                break;
        }
    }
}
#endif /* !defined(PLUS) */

/* Process 8250 receiver interrupts */
static
asyrxint(dev)
unsigned dev;
{
    unsigned base;
    register struct fifo *fp;
    char c;
  
    base = asy[dev].addr;
    fp = &asy[dev].fifo;
#if defined(PLUS)
    c = inportb(base+RXDATA);
    /* Process incoming data;
     * If buffer is full, we have no choice but
     * to drop the character
     */
    if(fp->cnt != fp->bufsize){
        *fp->wp++ = c;
        if(fp->wp == &fp->buf[fp->bufsize])
            /* Wrap around */
            fp->wp = fp->buf;
        fp->cnt++;
    }
#else   /* it' a PC */
    while(inportb(base+LSR) & LSR_DR){
        c = inportb(base+RBR);
        /* Process incoming data;
         * If buffer is full, we have no choice but
         * to drop the character
         */
        if(fp->cnt != fp->bufsize){
            *fp->wp++ = c;
            if(fp->wp == &fp->buf[fp->bufsize])
                /* Wrap around */
                fp->wp = fp->buf;
            fp->cnt++;
        }
    }
#endif
}

/* Handle Timeout waiting for 8250 Transmit Complete IRQ (assume lost IRQ) */
static
void
asy_xmt_to(dev)
unsigned dev;
{
	register struct dma *dp;

	/* Increment Timeout Count and Restart Timer */

	dp = &asy[dev].dma;
	dp->cnt_xmt_to++ ;
	set_timer(&dp->xmt_to,250);
	start_timer(&dp->xmt_to);

	/* Now get Transmitting going again */
	asytxint(dev);
}

/* Handle 8250 transmitter interrupts */
static
asytxint(dev)
unsigned dev;
{
    register struct dma *dp;
    register unsigned base;
    unsigned urg ; 			/* byte of Urgent Data, or == 256 */
  
    base = asy[dev].addr;
    dp = &asy[dev].dma;
    if(!dp->flags){
        /* "Shouldn't happen", but disable transmit
         * interrupts anyway
         */
#if defined(PLUS)
	setbit(base+INTRCONTROL,0xc0);
#else   /* it's a PC */
        clrbit(base+IER,IER_TxE);
#endif
        return; /* Nothing to send */
    }
#if defined(PLUS)
    while(inportb(base+STATUS) & 0x02){

	/* Reset Transmit Timeout to another 1/4 Second to go */
	dp->xmt_to.count = 250 / MSPTICK ;

	/* If Urgent Data pending, send it if possible */

	if (asy[dev].urgent != NULLCHAR)
	    if ((urg=(*asy[dev].urgent)(dev)) < 256) {
		outportb(base+TXDATA,urg) ;
		continue ;
	    }

	/* else transmit next byte of normal data (if any) */

	if (dp->cnt) {
		dp->last_octet = *dp->data ;
		outportb(base+TXDATA,*dp->data++);
		dp->cnt--;
	} else {
		/* Last Byte has been sent.  Cancel Transmit Cplt */
		stop_timer(&dp->xmt_to) ;

		dp->flags = 0;
        	/* Disable transmit interrupts */
        	setbit(base+INTRCONTROL,0xc0);
        	break;
        }
/*
 * turn em back on, we got more to do
 */
    	clrbit(base+INTRCONTROL,0x80);
    	setbit(base+INTRCONTROL,0x40);
    }
#else   /* it' a PC */
    while(inportb(base+LSR) & LSR_THRE){

	/* Reset Transmit Timeout to another 1/4 Second to go */
	dp->xmt_to.count = 250 / MSPTICK ;

	/* If Urgent Data pending, send it if possible */

	if (asy[dev].urgent != NULLCHAR)
	    if ((urg=(*asy[dev].urgent)(dev)) < 256) {
		outportb(base+THR,urg) ;
		continue ;
	    }

	/* else transmit next byte of normal data (if any) */

	if (dp->cnt) {
		dp->last_octet = *dp->data ;
		outportb(base+THR,*dp->data++);
		dp->cnt--;
	} else {
		/* Last Byte has been sent.  Cancel Transmit Cplt */
		stop_timer(&dp->xmt_to) ;

		dp->flags = 0;
		/* Disable transmit interrupts */
		clrbit(base+IER,IER_TxE);
        	/* Call completion interrupt here */
        	break;
        }
    }
#endif
}
int
stxrdy(dev)
int16 dev;
{
    return(!asy[dev].dma.flags);
}
/* Set bit(s) in I/O port */
  
setbit(port,bits)
unsigned port;
char bits;
{
    outportb(port,(char)inportb(port)|bits);
}
/* Clear bit(s) in I/O port */
clrbit(port,bits)
unsigned port;
char bits;
{
    outportb(port,(char)(inportb(port) & ~bits));
}
#if defined(PLUS)  
int init_com(dev,wordlen,parity)
int dev, wordlen;
char parity;
{
    int i, offset, sconfig;
    i=peek(0xffff,0x0e) & 0xff;
    if(i==0xb6) {
        model=1;            /* portable      */
	asy[dev].addr=0xa4;
        offset=i=0x60;
    }
    else
        if((i=='A') || (i=='B')) {
            model=0;            /* portable plus */
            offset=i=0;
        }
        else
            if(i>0xfb) model=2; /* pc type       */
    if(model==2) {
        return(offset=-1);
    }
/*
 * turn on port
 */
    outportb((unsigned)(asy[dev].addr+INTRCONTROL),
    	(unsigned char)0xf0); /* make sure no ints from serial */
    if(offset || asy[dev].addr==0x44) {
	serial_power(1);
    }
    else {
/*
 * commented out so we can use the modem
    	modem_power(1);
 */
    }
  
    i=wordlen-5;
    if ((i<0) || (i>3)) i=3;
    i=i<<6;
  
    sconfig=i | 2;             /* setup our local copy */
    switch(parity) {
        case 'n':
        case 'N':   i=0;
            break;
        case 'e':
        case 'E':   i=2;
            break;
        case 'o':
        case 'O':   i=3;
            break;
        default:
            i=0;
    }
    i=i<<2;
    sconfig|=i;
    if(offset || asy[dev].addr==0xa4) 
	modemconfig=sconfig;
    else
	serialconfig=sconfig;
/*
 * set up serial configuration register
 */
    outportb((unsigned)(asy[dev].addr+FORMATCONTROL),
    	(unsigned char)sconfig);
/*
 * interrupt on data avail
 */
    outportb((unsigned)(asy[dev].addr+INTRCONTROL+offset),
    	(unsigned char)0xd0);
    return 4;
} /* init_com */
  
#if 0  
/*
 * This code is if def'ed out. I left it in in case someone wanted to
 *  see how to read these lines.  WA7TAS
 */
/*
 * state of cts and dsr lines are inverted on the portable plus
 *  and not inverted on the portable. CTS is bit 6 on the portable,
 *  and bit 7 on the portable plus. DSR is bit 7 on the portable,
 *  and bit 6 on the portable plus.
 */
int cts()
{
    if(model==1) return((int)(inportb(0x2f) & 0x40));
    return(!((int)(inportb(0x2f) & 0x80)));
} /* cts */
  
int dsr()
{
    if(model==1) return((int)(inportb(0x2f) & 0x80));
    return(!((int)(inportb(0x2f) & 0x40)));
}
 /* dsr */
#endif  

void interrupt plustxsvec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asytxint(serialdev);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;
} /* plustxsvec */
/*
 * see turbo c user's guide page p283
 */

void interrupt plusrxsvec()
{
	register int tchar, dd;

	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	if((inportb(0x48) & 0x80) != 0) asyrxint(serialdev);
	outportb(0x48,serialconfig | 2);
	tchar=inportb(0x4c);
	tchar|=0x10;
	tchar&=(~0x20);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	outportb(0x4c,tchar);
} /* plusrxsvec */

void interrupt plustxmvec()
{
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	asytxint(modemdev);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;
} /* plustxmvec */
/*
 * see turbo c user's guide page p283
 */

void interrupt plusrxmvec()
{
	register int tchar, dd;
	asm mov ds:sssave,ss;
	asm mov ds:spsave,sp;

	_BX=intstk+512;
	_SS=_DS;	
	asm mov sp,bx

	if((inportb(0xa8) & 0x80) != 0) asyrxint(modemdev);
	outportb(0xaa8,modemconfig | 2);
	tchar=inportb(0xac);
	tchar|=0x10;
	tchar&=(~0x20);

	asm mov sp,ds:spsave;
	asm mov ss,ds:sssave;

	outportb(0xac,tchar);

} /* plusrmsvec */

void modem_power(on_off)
int on_off;
{
/*
 * open com3 file see 110+ tech ref page 6-18
 */
    _AX=0x3d02;
    _DX=com3_name;
    geninterrupt(0x21);
    com3handle=_AX;
/*
 * get com3 device status info
 */
    _BX=_AX;
    _AX=0x4400;
    geninterrupt(0x21);
/*
 * set raw bit
 */
    _BX=com3handle;
    _DH=0;
    _DL|=0x20;
    _AX=0x4401;
    geninterrupt(0x21);
/*
 * turn on rs232 port or off
 */
    if(on_off!=0) { /* turn it on */
	_BX=com3handle;
	_DX=ioctlon3;
	_CX=3;
	_AX=0x4403;
    }
    else {
	_DX=ioctloff3;
	_CX=3;
	_AX=0x4403;
	geninterrupt(0x21);
/*
 * close the file handle as we're done with it.
 */
	_BX=com3handle;
	_AX=0x3e00;
    }
    geninterrupt(0x21);
} /* modem_power */

void serial_power(on_off)
int on_off;
{
/*
 * open com1 file see 110+ tech ref page 6-18
 */
    _AX=0x3d02;
    _DX=com1_name;
    geninterrupt(0x21);
    com1handle=_AX;
/*
 * get com1 device status info
 */
    _BX=_AX;
    _AX=0x4400;
    geninterrupt(0x21);
/*
 * set raw bit
 */
    _BX=com1handle;
    _DH=0;
    _DL|=0x20;
    _AX=0x4401;
    geninterrupt(0x21);
/*
 * turn on rs232 port or off
 */
    if(on_off!=0) { /* turn it on */
	_BX=com1handle;
	_DX=ioctlon1;
	_CX=3;
	_AX=0x4403;
    }
    else {
	_DX=ioctloff1;
	_CX=3;
	_AX=0x4403;
	geninterrupt(0x21);
/*
 * close the file handle as we're done with it.
 */
	_BX=com1handle;
	_AX=0x3e00;
    }
    geninterrupt(0x21);
} /* serial_power */
#endif  /* defined PLUS */
